<?php
namespace Claromentis\Core\Like\Controller;

$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"] ?: array()) + array("_62d701c" . "3c53404f" . "06345eb3" . "5720a47b" . "4" => base64_decode("aXNfbnV" . "tZXJpYw" . "=="), "_71f564ea75084c6f" . "261db81c655d2f73" => base64_decode("cHJvZmlsZV9saW5rLmhyZW" . "Y="), "_5203b6250b088a619af741a56" . "f3a0c26" => base64_decode("Y29tbW9uL2xpa2UvbGlrZXJzX2xpc3QuaHRtbA" . "=="), "_2409bed918465b496" . "e1f712f2c651403" => base64_decode("bGlrZXJzLmRhdGFzcm" . "M="), "_5784e706ef84e048186a" . "70a164fcc358" => base64_decode("T2JqZWN0IElEIGlzIG5vdCBzc" . "GVjaWZpZWQgb3IgaW52YWxpZA" . "=="), "_aa45d9aa411eac890bad" . "ddfedf2ade38" => base64_decode("T2JqZWN0IHR5cGUg" . "aXMgbm90IHNwZWNp" . "ZmllZA=="), "_5e8488c301cda0085b5ca6c78c5068" . "7d" => base64_decode("cHJvZmlsZV9" . "waG90by5zcm" . "M="), "user" . "_id" => base64_decode("dXNlcl" . "9pZA=="), "_532af466" . "941018fd3" . "954ccc8ae" . "d6a235" => base64_decode("bG" . "lr" . "ZW" . "Q="), "_f4eafa5f493306ffdb51a688b21d" . "d507" => base64_decode("dG90YWw" . "="), "_37317e99fd1ac0bd2cca360fcc5fd61" . "2" => base64_decode("dXNlcl9uYW1lLmJvZH" . "k="));
use Claromentis\Core\Application;
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\StatusCode;
use Psr\Http\Message\ServerRequestInterface as Request;
use Claromentis\Core\Http\TemplaterCallResponse;
use RestFormat;






class RestV1Controller
{
    
    
    
    
    protected $formatter;
    
    
    
    
    public function __construct(RestFormat $formatter)
    {
        $this->formatter = $formatter;
    }
    
    
    
    
    
    
    
    
    public function AddLike(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $app->likes->Add($aggregation, $object_id, $app->security->GetUserId());
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_f4eafa5f493306ffdb5" . "1a688b21dd507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d, StatusCode::OK);
    }
    
    
    
    
    
    
    
    
    public function GetMeLiked(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_532af4669410" . "18fd3954ccc8a" . "ed6a235"] => (bool) $app->likes->IsLiked($aggregation, $object_id, $app->security->GetUserId())];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    public function GetLikesCount(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_f4eafa5f493306ffdb51" . "a688b21dd507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikes(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $_f4eafa5f493306ffdb51a688b21dd507 = $app->likes->GetCount($aggregation, $object_id);
        if ($_f4eafa5f493306ffdb51a688b21dd507 > 0) {
            $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        } else {
            $likes = [];
        }
        $_1f24efd4735b7a11b391147435e7d35d = $this->formatter->PagingContainer($likes, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2, $_f4eafa5f493306ffdb51a688b21dd507);
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikesHtml(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        $_e7438083ff42e99584f6022253250369 = [];
        foreach ($likes as $_9ecb1a728fdb50fbae4581f824a09366) {
            $user_id = $_9ecb1a728fdb50fbae4581f824a09366[$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["us" . "er" . "_i" . "d"]];
            $_343a395319323dd7609bcbc465b4d034 = [$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_71f564ea7" . "5084c6f261" . "db81c655d2" . "f73"] => \User::GetProfileUrl($user_id), $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_5e8488c301cda0085b5ca6c78c50" . "687d"] => \User::GetPhotoUrl($user_id), $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_37317e99fd1ac0bd2" . "cca360fcc5fd612"] => \User::GetNameById($user_id)];
            $_e7438083ff42e99584f6022253250369[] = $_343a395319323dd7609bcbc465b4d034;
        }
        $args = [$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_2409bed918465b496e1f712f2c6" . "51403"] => $_e7438083ff42e99584f6022253250369];
        $template = $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_5203b6250b088a619af741a56f3a0" . "c26"];
        return new TemplaterCallResponse($template, $args);
    }
    
    
    
    
    
    
    private function CheckObject($object_type, $object_id, Application $app)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_62d701c3c53404f06345" . "eb35720a47b4"]($object_type)) {
            $aggregation = \ClaAggregations::GetNumByCode($object_type);
        } elseif ($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_62d701c3c5" . "3404f06345e" . "b35720a47b4"]($object_type)) {
            $aggregation = (int) $object_type;
        }
        if (empty($aggregation)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_aa45d9aa411eac890badddfe" . "df2ade38"]);
        }
        if (!$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_62d701c3c53404f0634" . "5eb35720a47b4"]($object_id)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_5784e706ef84e048186" . "a70a164fcc358"]);
        }
        
        
        return array($aggregation, $object_id);
    }
}